
program move4;

uses
  SysUtils;

// http://docs.embarcadero.com/products/rad_studio/delphiAndcpp2009/HelpUpdate2/EN/html/delphivclwin32/System_Move.html

{
  This example moves characters from a Char array into an integer.
  Displaying the integer as a hex, you can see that 'W' (0x57) is
  stored in the least significant byte of the integer.
}

var
  A: array[1..4] of Char;
  B: Integer;

procedure DisplayAB;
begin
  WriteLn(A[1]);
  WriteLn(A[2]);
  WriteLn(A[3]);
  WriteLn(A[4]);
  WriteLn(IntToHex(B, 1));
end;

begin
  A[1] := 'W';
  A[2] := 'H';
  A[3] := 'A';
  A[4] := 'T';
  B := 5;
  DisplayAB;
  Move(A, B, SizeOf(B));
  DisplayAB;
  ReadLn;
end.
