
// http://docs.embarcadero.com/products/rad_studio/delphiAndcpp2009/HelpUpdate2/EN/html/delphivclwin32/SysUtils_StrMove@PAnsiChar@PAnsiChar@Cardinal.html

program strmove2;

uses
  Classes, SysUtils;

{
This example shows two functions that do the same thing as
StrNew and StrDispose.
}

function AHeapaString(S: PChar): PChar;
var
  L: Cardinal;
  P: PChar;
  StrNew: PChar;
begin
  StrNew := nil;
  if (S <> nil) and (S[0] <> #0) then
  begin
    L := StrLen(S) + 1;
    GetMem(P, L);
    StrNew := StrMove(P, S, L);
  end;
  Result := StrNew;
end;

procedure DisposeDaString(S: PChar);
begin
  if S <> nil then
    FreeMem(S, StrLen(S) + 1);
end;

var
  S, otherS: PChar;
begin
  S := 'Now you see it';
  otherS := AHeapaString(S);
  WriteLn(otherS = 'Now you see it');
  DisposeDaString(otherS);
  ReadLn;
end.
