
unit Log;

interface

uses
  SysUtils, Windows;

type
  TLog = class
    class procedure Append(const aLine: string; const aSecondFile: boolean = FALSE);
  end;

implementation

var
  vLog: array[boolean] of text;

class procedure TLog.Append(const aLine: string; const aSecondFile: boolean);
begin
  WriteLn(vLog[aSecondFile], DateTimeToStr(Now()) + ' ' + aLine);
  Flush(vLog[aSecondFile]);
  Sleep(10);
end;

const
  EXT: array[boolean] of string = ('.log', '-extra.log');
var
  s: string;
  b: boolean;
  
initialization
  for b := FALSE to TRUE do
  begin
    s := ChangeFileExt(ParamStr(0), EXT[b]);
    Assign(vLog[b], s);
    Rewrite(vLog[b]);
  end;
  
finalization
  for b := FALSE to TRUE do
    Close(vLog[b]);
  
end.
